/****************************************************************************
	PROFFT.H	 Denne filen inneholder (i denne rekkeflgen):
*****************************************************************************
PROTOTYPER:
extern HANDLE hByteToComplexTable;
extern BOOL bCircleRubber;
extern BOOL bShiftCenter;
void SetBMPPixel(HANDLE hBitmap, int iX, int iY, int iW, int iH, BYTE Colour);
BYTE GetBMPPixel(HANDLE hBitmap, int iX, int iY, int iW, int iH);
void SetComplex(HANDLE hComplex, int iX, int iY, int iW, int iH, prcomplex *compZ);
void GetComplex(HANDLE hComplex, int iX, int iY, int iW, int iH, prcomplex *compZ);

KLASSEDEFINISJONER:
class TPROffApp : public TApplication
class TMainWindow : public TMDIFrame
class TProgressDialog : public TDialog
class TGenericPicWindow : public TWindow
class TPictureWindow : public TGenericPicWindow
class TComplexWindow : public TGenericPicWindow
class TPROfftFileDialog : public TFileDialog
class TFilter1 : public TDialog
class TFilter2 : public TDialog
class TOptions : public TDialog
****************************************************************************/

#ifndef __PROFFT_H
#define __PROFFT_H

#ifndef __STRING_H
#include <string.h>
#endif

#ifndef __FILEDIAL_H
#include <filedial.h>
#endif

#ifndef __PROFFTID_H
#include "profftid.h"
#endif

#ifndef __PRCOMP_H
#include "prcomp.h"
#endif

/****************************************************************************
Se PROFFT.CPP for deklarering av variablene under
****************************************************************************/
extern HANDLE hByteToComplexTable;
extern BOOL bCircleRubber;
extern BOOL bShiftCenter;


/****************************************************************************
							SetBMPPixel (see MISCFUNC.CPP for description)
****************************************************************************/
void SetBMPPixel(HANDLE hBitmap, int iX, int iY, int iW, int iH, BYTE Colour);


/****************************************************************************
							GetBMPPixel (see MISCFUNC.CPP for description)
****************************************************************************/
BYTE GetBMPPixel(HANDLE hBitmap, int iX, int iY, int iW, int iH);


/****************************************************************************
							SetComplex (see COMPWIN.CPP for description)
****************************************************************************/
void SetComplex(HANDLE hComplex, int iX, int iY, int iW, int iH, prcomplex *compZ);


/****************************************************************************
							GetComplex (see COMPWIN.CPP for description)
****************************************************************************/
void GetComplex(HANDLE hComplex, int iX, int iY, int iW, int iH, prcomplex *compZ);


/****************************************************************************
										fft (see FFT.CPP for description)
****************************************************************************/
int fft(prcomplex *z1, prcomplex *z2, int n);


/****************************************************************************
								PowerOf2 (see GENPWIN.CPP for description)
****************************************************************************/
int PowerOf2(long l);


class TPROffApp : public TApplication
/****************************************************************************
Starter opp applikasjonen. Instansieres av statisk variabel i WinMain.
Konstruktoren kaller InitMainWindow() som vi har tatt over i vr applikasjon,
og vi fr dermed kontrollen.

Superklasser:	TApplication

Subklasser: Ingen.

Kompatibilitet:  Kun med ObjectWindows klassebibliotek for Borland C++ 3.0.

Skrevet av: MK

Sist forandret:
	12.3.92/MK: Lagde klassedefinisjonen
***************************************************************************/
{
public:
	TPROffApp(LPSTR AName, HANDLE hInstance, HANDLE hPrevInstance,
		LPSTR lpCmdLine, int nCmdShow)
		: TApplication(AName, hInstance, hPrevInstance, lpCmdLine, nCmdShow)
		{HAccTable=LoadAccelerators(hInstance, "PROFFTACC");};
private:
	virtual void InitMainWindow();
};

class TMainWindow : public TMDIFrame
/****************************************************************************
Dette er hovedobjektet (hovedvinduet) i applikasjonen vr. Det er dette
vinduet som mottar alle beskjeder fra menyen og som sender beskjeden
videre til et eventuellt barnevindu (TPictureWindow eller TComplexWindow).
Det hndterer ogs alle barnevinduer m.h.p. posisjon, ikonisering o.l.

Alle medlemsfunksjonene finnes og er nrmere beskrevet i MAINWIN.CPP.

Instansieres av TApplication.InitMainWindow()

Superklasser:	TMDIFrame

Subklasser:	Ingen.

Skrevet av:	MK

Sist forandret:
	12.3.92/MK: Lagde klassedefinisjonen
	24.3.92/MK: La inn initialiseringskode for  lage 64 fargers grtonepalette.
	24.4.92/MK: Forandret fra 64 til 256 grtoner.
Eventuellt:
****************************************************************************/
{
public:
	//  Initialisering og deallokering..
	TMainWindow(LPSTR ATitle);
	~TMainWindow();

	//  Opprettelse av barnevinduer/objekter..
	virtual PTWindowsObject CreateChild(LPSTR FileName,
																BITMAPINFO *bmpInfo, HBITMAP hBitmap);
	virtual PTWindowsObject CreateComplexChild(LPSTR lpszCaption,
			HANDLE hComplexPict, BITMAPINFO *bmpInfo, HANDLE hBitmap);

	//  Flgende funksjoner svarer p beskjeder fra Windows..
	BOOL WMQueryNewPalette(TMessage&) = [WM_QUERYNEWPALETTE];
	virtual void WMIdle(TMessage& Msg) = [WM_ENTERIDLE];
	virtual void WMDrawClipboard(TMessage& Msg) = [WM_DRAWCLIPBOARD];
	virtual void WMChangeCBChain(TMessage& Msg) = [WM_CHANGECBCHAIN];

	//  Flgende funksjoner svarer p menyvalg fra vr applikasjon..
	virtual void CMFileOpen(TMessage&) = [CM_FIRST + CM_MDIFILEOPEN];
	virtual void CMFileSaveAs(TMessage&) = [CM_FIRST + CM_FILESAVEAS];
	virtual void CMEditCut(TMessage&) = [CM_FIRST + CM_EDITCUT];
	virtual void CMEditCopy(TMessage&) = [CM_FIRST + CM_EDITCOPY];
	virtual void CMEditPaste(TMessage&) = [CM_FIRST + CM_EDITPASTE];
	virtual void CMTransformFFT(TMessage&) = [CM_FIRST + CM_TRANSFFT];
	virtual void CMTransformInvert(TMessage&) = [CM_FIRST + CM_TRANSINVERT];
	virtual void TMainWindow::CMTransformIFFT(TMessage&) = [CM_FIRST + CM_TRANSIFFT];
	virtual void CMFilterLowpass(TMessage&) = [CM_FIRST + CM_FILTERLOWPASS];
	virtual void CMFilterBandpass(TMessage&) = [CM_FIRST + CM_FILTERBANDPASS];
	virtual void CMFilterHighpass(TMessage&) = [CM_FIRST + CM_FILTERHIGHPASS];
	virtual void CMFilterBandstop(TMessage&) = [CM_FIRST + CM_FILTERBANDSTOP];
	virtual void CMFilterBWLowpass(TMessage&) = [CM_FIRST + CM_FILTERBWLOWPASS];
	virtual void CMFilterBWHighpass(TMessage&) = [CM_FIRST + CM_FILTERBWHIGHPASS];
	virtual void CMFilterFreehand(TMessage&) = [CM_FIRST + CM_FILTERFREEHAND];
	virtual void CMFilterOptions(TMessage&) = [CM_FIRST + CM_FILTEROPTIONS];
	virtual void CMHelpIndex(TMessage&) = [CM_FIRST + CM_HELPINDEX];
	virtual void CMHelpAbout(TMessage&) = [CM_FIRST + CM_HELPABOUTPROFFT];

	//  Stttefunksjoner for andre som bruker dette objektet
	//  sine datamedlemmer.
	void SetRubberSize(int iSize);
	int GetRubberSize();
	HPALETTE CreateGrayscalePalette();

	//  Medlemsvariable..
	HPALETTE hPal;		//  Brukes av TPictureWindow og TComplexWindow
										//  Inneholder en handle til en 256 grtoners
										//  palette. Sparer plass ved  si at alle
										//  barnevinduene bruker hovedvinduet sin palette.
	HCURSOR hcrWait;	//  Brukes av flere for  vise timeglasset.
										//  Hentes fram under initialisering av TMainWindow
										//  objektet og brukes siden av forskjellige objekter
										//  i systemet for  vise timeglasset.
	HPEN hRubber;			//  Brukes av TComplexWindow til  tegne filtre.
										//  Lages under initialisering av TMainWindow.
	HCURSOR hcrRubber;//  Brukes av TComplexWindow for  tegne filtercursor
										//  Lages under initialiseringen av TMainWindow.
										//  Forandres hvis brukeren forandre strrelse/
										//  form i TOptions dialogboksen.
private:
	//  Private stttefunksjoner
	void SetupWindow();
	virtual BOOL CanClose();
	BOOL CheckForHelp(int CM_ID);
	BOOL LoadBitmapFile(LPSTR Name);
	BOOL SaveBitmapFile(LPSTR Name);
	BOOL OpenDIB(int TheFile, LPSTR FileName);
	void GetBitmapData(int TheFile, HANDLE BitsHandle, long BitsByteSize);
	void WriteBitmapData(int TheFile, HANDLE BitsHandle,long BitsByteSize);
	void CreateClipboardChild();
	void ChangeRubber();
	virtual void GetWindowClass(WNDCLASS& wc);
	virtual LPSTR GetClassName();

	HWND hwndNextViewer;	//  Handle til neste vindu i Clipboardviewer
												//  kjeden. Kreves av Windows for at man skal
												//  f tilgang til clipboard dataene og beskjed
												//  nr dataene forandres. Brukes av
												//  WMDrawClipboard og WMChangeCBChain.
	int iRubberSize;			//  Inneholder strrelsen p viskelret.
												//  Brukes av SetRubberSize og GetRubberSize.
												//  Forandres nr brukeren velger ny strrelse
												//  i Options dialogboksen.
	BOOL bHelp;						//  Settes hvis brukeren trykker hjelp.
												//  Oppdateres av WMIdle som sjekker om
												//  brukeren trykker shift F1.

	//  De flgende variable brukes til  lage viskelrcursoren.
	//  De initialiseres i SetupWindow og forandres senere v.h.a.
	//  SetRubberSize som kalles nr brukeren velger Options
	//  dialogboksen.
	HDC hdcBitmap;
	int cxCursor, cyCursor, cbSize;
	HBITMAP hbm, hbmOld;
	HANDLE hmemAND, hmemXOR;
	LPSTR lpAND, lpXOR;
	HBRUSH hbrWhite, hbrBlack;
};

class TProgressDialog : public TDialog
/****************************************************************************
Dette er en dialogboks som viser hvor langt brukeren er kommet i en
tidkrevende operasjon. Den srger ogs for at brukeren har muligheten
for  avbryte en operasjon.

Instansieres av	tidkrevende operasjoner i TPictureWindow og
TComplexWindow (FFT og en del operasjoner i den forbindelsen).

Alle medlemsfunksjonene finnes og er nrmere beskrevet i PROFFTDB.CPP.

Superklasser:	TDialog

Subklasser:	Ingen

Skrevet av:
	MK
****************************************************************************/
{
public:
	TProgressDialog(PTWindowsObject AParent, LPSTR lpszDialogName, LPSTR lpszCaption);
	~TProgressDialog();

	//  Svarer p beskjeder fra Windows
	virtual void WMInitDialog(RTMessage Msg) = [WM_FIRST + WM_INITDIALOG];
	virtual void WMCommand(RTMessage Msg) = [WM_FIRST + WM_COMMAND];

	//  Svarer p beskjeder fra foreldreobjektet (det objektet som
	//  instansierte objektet).
	virtual void WMSetText(RTMessage Msg) = [WM_FIRST + WM_SETPROGRESSTEXT];
	virtual void WMSetProgress(RTMessage Msg) = [WM_FIRST + WM_SETPROGRESS];

	//  Gir foreldreobjektet mulighet for  sjekke om brukeren har
	//  avbrutt den nvrende operasjonen.
	BOOL CancelPressed();
private:
	BOOL bCancel;		//  Inneholder hvorvidt brukeren har trykket
									//  p Cancel knappen. Initialiseres til FALSE
									//  ved initialisering av objektet. Settes til
									//  TRUE hvis objektet mottar beskjed fra Windows
									//  om at Cancelknappen er trykket (gjennom WMCommand).

	//  Inneholder teksten i dialogboksen
	char acPercentage[5];
	char acMessage[MAX_CAPTION_LENGTH];

	//  Inneholder prosent ganger 100 hvor langt vi er kommet hittil.
	//  Brukes i WMSetProgress for  sjekke om vi er kommet lenger enn
	//  forrige gang (i %).
	long lSoFar;

	//  Handle til pennen vi tegner i prosentfirkanten. Initialiseres
	//  ved initialisering av objektet, deallokeres i destructoren.
	HBRUSH hBrush;

	//  Husker tegneflaten til denne dialogboksen. Initialiseres
	//  sammen med objektet.
	HDC hdc;
	RECT rect;

	//  Handle til Cancelknappen. Initialiseres sammen med objektet.
	HWND hCtrl;
};

class TGenericPicWindow : public TWindow
/****************************************************************************
Dette er superklassen til TPictureWindow og TComplexWindow. Denne klassen
inneholder de generelle tingene som begge subklassene trenger, f.eks.
standard vindushndtering.

Instansieres av	konstruktoren i TPictureWindow eller TComplexWindow.

Alle medlemsfunksjonene finnes og er nrmere beskrevet i GENPWIN.CPP.

Superklasser:	TWindow

Subklasser:	TPictureWindow, TComplexWindow

Skrevet av:
	MK
Sist forandret:
	12.3.92/MK: Lagde klassedefinisjonen
	20.4.92/MK: La inn stttefunksjoner for lettere kopiering av nye
							objekter, samt muligheten for  manipulere bitmaps
							som ikke ndvendigvis var allokert av objektet (dvs.
							gjre ting over i en ny bitmap).
****************************************************************************/
{
public:
	//  Initialisering og deallokering
	TGenericPicWindow(PTWindowsObject AParent, LPSTR FileName,
									BITMAPINFO *bmpInfo, HANDLE hBitmap, BOOL bBitmap);
	virtual ~TGenericPicWindow();

	//  Svarer p beskjeder fra Windows
	virtual void WMSize(TMessage&) = [WM_FIRST + WM_SIZE];
	virtual void Paint(HDC, PAINTSTRUCT&);

	//  Funksjoner som dette objektet kan gjre med seg selv
	void EditCopy();  //  Kopierer DIBitmap over i clipboard

	//  Peker til bildestrukturdataene, som inneholder strrelse,
	//	farger i bildet osv. (se beskrivelse av BITMAPINFO struktur).
	//  Brukes av TPictureWindow og TComplexWindow objektene.
	LPBITMAPINFO bmpInfo;

	//  Handle til selve bitmappen. Initialiseres i konstruktoren og
	//  brukes senere av LockBMP og UnlockBMP og
	//  av TPictureWindow og TComplexWindow objektene.
	HANDLE hBitmap;

	//  Husker opprinnelsen til objektet (vanligvis filnavn, men kan
	//  ogs komme fra clipboard.
	//  Brukes av TPictureWindow og TComplexWindow objektene.
	char FileName[MAXPATH];

	//  Stttefunksjoner for hndtering/duplisering av objektet.
	//  Brukes av TPictureWindow og TComplexWindow objektene.
	void CopyBMP(HANDLE hSourceBitmap, HANDLE hTargetBitmap);
	void CopyBMPInfo(LPSTR source, LPSTR target);
	void AdjustScroller();
	BITMAPINFO* MakeDuplicateBMPInfo(LPBITMAPINFO source);

	//  Stttefunksjoner for  f tilgang til bitmappen
	BOOL LockBMP();
	void UnlockBMP();

	//  Peker til bitmappen. MERK! Denne er ikke gyldig fr LockBMP
	//  er kallt. Da er den gyldig til UlockBMP kalles igjen.
	char huge *hpBitmap;

	//  En peker til en Statusdialogboks som viser hvor langt vi er
	//  kommet i en operasjon og gir brukeren muligheten for  avbryte.
	TProgressDialog *pdbProgress;
};

class TPictureWindow : public TGenericPicWindow
/****************************************************************************
Dette er subklassen til TGenericPicWindow og er det objektet som brukes
til  vise "simple" bitmapbilder p skjermen. Disse kan enten hentes fra
disk eller fra clipboard. Den har bare en utvidelse i forhold til
TGenericPicWindow, nemlig FFT transformen som tar seg av  transformere
bildet over i et TComplexWindow objekt.

Instansieres av	TMainWindow.CreateChild(..).

Alle medlemsfunksjonene finnes og er nrmere beskrevet i PICTWIN.CPP.

Superklasse: TGenericPicWindow

Subklasse: Ingen.

Skrevet av: MK

Sist forandret:
	12.3.92/MK: Lagde klassedefinisjonen
****************************************************************************/
{
public:
	//  Initialisering
	TPictureWindow(PTWindowsObject AParent, LPSTR FileName,
									BITMAPINFO *bmpInfo, HANDLE hBitmap) :
			TGenericPicWindow(AParent, FileName, bmpInfo, hBitmap, TRUE) {};

	//  Svarer p beskjeder fra Windows
	virtual void WMMDIActivate(RTMessage Msg) = [WM_FIRST + WM_MDIACTIVATE];

	//  Utfrer FFT p dette bildeobjektet. Instansierer et
	//  TComplexWindow objekt ved  kalle TMainWindow.CreateComplexChild
	//  og kopiere seg selv over i dette. Deretter ber det om at det
	//  nye komplekse objektet utfrer FFT p seg selv. Kalles fra
	//  TMainWindow.CMTransformFFT.
	void PerformFFT();

	//  Inverterer seg selv. Kalles fra CMTransformInvert.
	void Invert();
private:
	//  Setter de aktuelle menyvalg for dette objektet. Kalles ved
	//  aktivisering av dette objektet (vinduet) v.h.a. WMMDIActivate.
	void SetMenuItems(WORD wStatus);

	//  Registrerer vindusklassen og velger standardicon
	virtual void GetWindowClass(WNDCLASS& wc);
	virtual LPSTR GetClassName();

};

class TComplexWindow : public TGenericPicWindow
/****************************************************************************
Dette er subklassen til TGenericPicWindow og er det objektet som brukes
til de komplekse bildene. Det bildet som synes p skjermen er en
logaritmisk amplitude/frekvens representasjon. De egentlige dataene
ligger p et eget allokert omrde (pekt p av ComplexPicture pekeren).

Instansieres av	TMainWindow.CreateComplexChild(..)

Alle medlemsfunksjonene med unntak av ExecuteSmallDialog() og
ExecuteLargeDialog() finnes og er nrmere beskrevet i COMPWIN.CPP.
De to frstnevne finnes sammen med de andre dialogboksene i PROFFTDB.CPP.

Superklasse: TGenericPicWindow

Subklasse: Ingen.

Skrevet av:	MK
Sist forandret:
	12.3.92/MK: Lagde klassedefinisjonen
	20.4.92/MK: La inn filtre m.m.
****************************************************************************/
{
public:
	//  Initialisering og deallokering
	TComplexWindow(PTWindowsObject AParent, LPSTR lpszCaption,
			HANDLE hComplexPict, BITMAPINFO *bmpInfo, HANDLE hBitmap);
	~TComplexWindow();

	//  Svarer p Windows beskjeder
	virtual void WMMDIActivate(RTMessage) = [WM_FIRST + WM_MDIACTIVATE];
	virtual void WMSetCursor(RTMessage Msg) = [WM_FIRST + WM_SETCURSOR];
	virtual void Paint(HDC, PAINTSTRUCT& PaintStruct);
	virtual void WMLButtonDown(RTMessage Msg) = [WM_FIRST + WM_LBUTTONDOWN];
	virtual void WMLButtonUp(RTMessage Msg) = [WM_FIRST + WM_LBUTTONUP];
	virtual void WMRButtonDown(RTMessage) = [WM_FIRST + WM_RBUTTONDOWN];
	virtual void WMMouseMove(RTMessage Msg) = [WM_FIRST + WM_MOUSEMOVE];

	//  Operasjoner som det komplekse objektet kan utfre p seg selv.
	//  Alle operasjoner som gjres p det komplekse objektet skjer ved
	//  at objektet frst lager en kopi av seg selv og utfrer operasjonen
	//  p kopien. Orginalen beholdes alltid!
	void PerformIFFT();							 // Inverstransformen
	void PerformFFT();							 // Vanlig fouriertransform
	void ExecuteFilter(HDC hdcMem);  // Filtrering

	//  Starter filterdialogboksene og kaller PrepareToExecuteFilter()
	//  hvis brukeren avslutter dialogboksen ved  trykk OK knappen.
	void ExecuteSmallDialog();			 // Filtre med en radius
	void ExecuteLargeDialog();			 // Filtre med to radiuser
	void PrepareToExecuteFilter();	 // Klargjring for filtrering

	//  Nedenfor flger en del statusdata om objektets tilstand.
	//  Disse dataene kunne med fordel
	//  ha blitt flyttet over i konstruktoren og blitt satt der, slik
	//  at vi kunne unngtt og ha de som public i dette objektet, men
	//  dessverre rakk ikke tiden til.. Dataene kopieres over i det
	//  nye objektet og settes slik at objektet oppdaterer seg selv
	//  ved  vise sin komplekse representasjon.

	//  Minste og strste radius i filterdialogboksen.
	int iLowerValue;
	int iUpperValue;

	//  Type filter som er utfrt p dette objektet.
	int iFilterType;

	//  Forteller om det komplekse bildet i objektet er sentrert.
	BOOL bWasShiftCentered;

	//  Forteller om Paint rutinen skal vise filterverdiene som rde
	//  sirkler i bildet.
	BOOL bShowFilter;

	//  Forteller om det er ndvendig  lage bitmappen p nytt fra det
	//  komplekse bildet. Det er for eksempel ikke ndvendig ved de filtrene
	//  som fjerner deler av frekvensplanet, da tegner vi rett i det komplekse
	//  og rett inn i bitmappen samtidig. Men med Butterworth filtrene som
	//  modifiserer alle punktene i det komplekse bildet m vi lage hele
	//  bitmapbildet p nytt.
	BOOL bDirty;

	//  Forteller om det er ndvendig  foreta reskalering av det komplekse
	//  bildet. Dette gjres ikke ved fjerning av deler i frekvensplanet,
	//  da vi ville ftt et gap fra 0 til den minste amplituden som ville
	//  blitt reservert til en del grtoner, selv om det faktisk ikke er
	//  noen deler som havner i denne rangen. Men ved bruk av Butterworth
	//  er vi ndt til  reskalere bildet fordi denne forandrer p rangen
	//  av hvilke grtoner vi trenger  vise.
	BOOL bRescale;

private:
	//  Tidkrevende stttefunksjoner i forbindelse med transformen.
	//  Alle returnerer TRUE hvis operasjonen ble fullfrt, FALSE
	//  ellers. Hvis en operasjon ble avbrutt srger kallrutinen for
	//   rydde opp, slik at alt blir som fr operasjonen ble satt i
	//  gang.
	BOOL FFT(HANDLE hTarget);
	BOOL UpdateBitmap();
	BOOL ConvertBMPToComplex(HANDLE hSourceBitmap, HANDLE hTargetComplex);
	BOOL ConvertComplexToBMP(HANDLE hSourceComplex, HANDLE hTargetBitmap);
	BOOL MakeComplexConjugate(HANDLE hComp);

	//  Stttefunksjoner for objektet

	//  Setter/tar vekk de aktuelle menyvalgene nr vinduet blir
	//  aktivert deaktivert
	void SetMenuItems(WORD wStatus);
	//  Kopierer et komplekst bilde over i et annet.
	void CopyComplex(HANDLE hSource, HANDLE hTarget);
	//  Locker det komplekse bildet, setter hpComplex til  peke
	//  p bildet.
	BOOL LockComplex();
	//  Unlocker det komplekse bildet.
	void UnlockComplex();
	//  Tegner med rdt hvis museposisjonen befinner seg innenfor
	//  bildet i klientomrdet. Kalles av WMLButtonDown og
	//  WMMouseMove.
	void DrawFreehand(RTMessage Msg);

	//  Registrerer vindusklassen og velger standardicon
	virtual void GetWindowClass(WNDCLASS& wc);
	virtual LPSTR GetClassName();

	//  Brukes til  lagre strste og minste verdi i bildet ved reskalering.
	//  Dette gjres for at vi skal representere det komplekse bildet
	//  best mulig ved hjelp av de grtonene vi har til rdighet.
	real MaxLogAmplitude, MinLogAmplitude;

	//  Handle til det komplekse bildet. Brukes av LockComplex og
	//  UnlockComplex.
	HANDLE hComplex;

	//  Huge pointer til det komplekse bildet. Kun brukbar etter
	//  en LockComplex (men ikke etter UnlockComplex).
	prcomplex huge *hpComplex;

	//  Forteller om brukeren har venstre museknapp nede. Settes og
	//  brukes av WMLButtonDown, WMLButtonUp, WMRButtonDown og WMMouseMove.
	BOOL bButtonDown;

	//  Diverse variable som holder status til den flaten vi tegner
	//  p ved frihndsfiltrering. Inneholder ogs brushen og
	//  pennen vi tegner med.
	HDC DragDC;
	HBRUSH hbrRed;
	HPEN hpenRed;

	//  Denne fr vite fra Windows v.h.a. en SetPixel ved initialisering
	//  av objektet hvordan dette datasystemet representerer fargen rd
	//  slik at frihndsfilteret kan finne igjen denne fargen ved senere
	//  filtrering.
	DWORD rgbRed;

	//  Et komplekst tall som settes = 0 ved initialisering av objektet.
	//  Denne verdien brukes ved nullstilling av deler av det komplekse
	//  bildet (raskere  kopiere en verdi en  "regne" om til null hver
	//  gang).
	prcomplex compZero;
};


class TPROfftFileDialog : public TFileDialog
/****************************************************************************
Standardobjektet som brukes i forbindelse med filpning og lagring.
Kalles fra TMainWindow.CMFileOpen og TMainWindow.CMFileSaveAs nr brukeren
velger Open eller Save As fra menyen.

Superklasser:  TFileDialog

Subklasser:		Ingen.

Skrevet av:
	MK
Sist forandret:
	12.3.92/MK: Lagde klassedefinisjonen
****************************************************************************/
{
public:
	//  Initialisering. Kaller den aktuelle fildialogboksen. ResourceID
	//  inneholder CM_FILEOPEN eller CM_FILESAVEAS ettersom vi nsker
	//  en filpne eller fillagre dialogboks.
		TPROfftFileDialog(PTWindowsObject AParent, int ResourceId,
									 LPSTR AFilePath, PTModule AModule = NULL)
		 : TFileDialog(AParent, ResourceId, AFilePath, AModule)
			 { strcpy(Extension, ".bmp"); } // Sender med default file extension.
};


class TFilter1 : public TDialog
/****************************************************************************
Dette er dialogboksen som brukes ved alle filtre som krever en radius.
Dvs. CM_FILTERLOWPASS, CM_FILTERHIGHPASS, CM_FILTERBWLOWPASS,
CM_FILTERBWHIGHPASS. Konstruktoren bare setter opp
kontrollene i dialogboksen.

Skrevet av:
	SA.
Sist forandret:
	30.03.92  SA  Lagde klassedefinisjonen.
	21.04.92  MK  Sttte for "hold and drag" scrollbarene med oppdatering.
****************************************************************************/
{
public:
	//  Initialisering
	TFilter1(PTWindowsObject AParent, LPSTR AName);

	//  Svarer p beskjeder fra Windows
	virtual void WMHScroll(RTMessage Msg) = [WM_FIRST + WM_HSCROLL];
	virtual void WMInitDialog(RTMessage Msg) = [WM_FIRST + WM_INITDIALOG];

	//  Svarer p beskjeder fra Windows ved aktivisering av de forskjellige
	//  kontrollene. Brukes for  oppdatere alle feltene i dialogboksen.
	virtual void IDHScrollBar(RTMessage Msg) = [ID_FIRST + DB_SCROLLFREQUENCY];
	virtual void IDEditFrequency(RTMessage Msg) = [ID_FIRST + DB_EDITFREQUENCY];

	//  Returnerer om vi tillater lukning av boksen (om verdiene er lovlige).
	virtual BOOL CanClose();
private:
	//  Oppdaterer foreldreobjektet sine parametre (hvis brukeren avslutter
	//  ved  trykke OK knappen).
	void UpdateParent();

	//  Brukes til  lagre maksimalverdien for radiusen (sparer oss for
	//  gjentatte flyttallsoperasjoner).
	int iMax;
};

class TFilter2 : public TDialog
/****************************************************************************
Dette er dialogboksen som brukes ved alle filtre som krever to radiuser.
Dvs. CM_FILTERBANDPASS, CM_FILTERBANDSTOPP. Konstruktoren bare setter opp
kontrollene i dialogboksen.

Skrevet av:
	SA.
Sist forandret:
	30.03.92  SA  Lagde klassedefinisjonen.
	21.04.92  MK  Sttte for "hold and drag" scrollbarene med oppdatering.
****************************************************************************/
{
public:
	//  Initialisering
	TFilter2(PTWindowsObject AParent, LPSTR AName);

	//  Svarer p beskjeder fra Windows
	virtual void WMInitDialog(RTMessage Msg) = [WM_FIRST + WM_INITDIALOG];
	virtual void WMHScroll(RTMessage Msg) = [WM_FIRST + WM_HSCROLL];

	//  Svarer p beskjeder fra Windows ved aktivisering av de forskjellige
	//  kontrollene. Brukes for  oppdatere alle feltene i dialogboksen.
	virtual void IDHScrollBar1(RTMessage Msg) = [ID_FIRST + DB_SCROLLFREQUENCY1];
	virtual void IDHScrollBar2(RTMessage Msg) = [ID_FIRST + DB_SCROLLFREQUENCY2];
	virtual void IDEditFrequency1(RTMessage Msg) = [ID_FIRST + DB_EDITFREQUENCY1];
	virtual void IDEditFrequency2(RTMessage Msg) = [ID_FIRST + DB_EDITFREQUENCY2];

	//  Returnerer om vi tillater lukning av boksen (om verdiene er lovlige).
	virtual BOOL CanClose();
private:
	//  Oppdaterer foreldreobjektet sine parametre (hvis brukeren avslutter
	//  ved  trykke OK knappen).
	void UpdateParent();

	//  Brukes til  lagre maksimalverdien for radiusen (sparer oss for
	//  gjentatte flyttallsoperasjoner).
	int iMax;
};

/****************************************************************************
Dette er dialogboksen som lar brukeren forandre p standardopsjonene i programmet.
Allokerer objektene i dialogboksen. Sender parametrene videre til
superklassen som henter dialogboksen fra ressursfilen.
class TOptions

Skrevet av:
	SA.
Sist forandret:
	05.04.92  SA  Lagde klassedefinisjonen.
	21.04.92  MK  La inn sttte for "hold and drag" p scrollbarene.
	25.04.92	MK	Opsjon for  sentrere i frekvensplanet.
								Radiobuttons for forskjellige typer viskelr.
****************************************************************************/
class TOptions : public TDialog
{
public:
	//  Initialisering
	TOptions(PTWindowsObject AParent, LPSTR AName);

	//  Svarer p Windows beskjeder
	virtual void WMInitDialog(RTMessage Msg) = [WM_FIRST + WM_INITDIALOG];
	virtual void WMCommand(RTMessage Msg) = [WM_FIRST + WM_COMMAND];
	virtual void WMHScroll(RTMessage Msg);

	//  Svarer p Windows beskjeder nr brukeren aktiverer scrollbaren
	//  i dialogboksen.
	virtual void IDHScrollBar(RTMessage Msg) = [ID_FIRST + DB_SCROLLRUBBER];

	//  Sjekker om brukeren avslutt med OK knappen. Hvis s, oppdater
	//  datamedlemmene fra slik de n er satt i dialogboksen.
	virtual void CloseWindow(int iRetValue);
};

#endif